Package: org.grails.web.mapping

## [Java] Class DefaultUrlMappingsHolder

- org.grails.web.mapping.DefaultUrlMappingsHolder

- All Implemented Interfaces and Traits:
    UrlMappings

      @java.lang.SuppressWarnings("rawtypes")
      public class DefaultUrlMappingsHolder
      extends java.lang.Object

  Default implementation of the UrlMappingsHolder interface that takes a list of mappings and then sorts them according to their precedence rules as defined in the implementation of Comparable.

  Authors:
    Graeme Rocher
  See Also:
    UrlMapping
    java.lang.Comparable
  Since:
    0.4

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static UrlMappingInfo[]` | `EMPTY_RESULTS` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DefaultUrlMappingsHolder (java.util.List<UrlMapping> mappings)`
    `DefaultUrlMappingsHolder (java.util.List<UrlMapping> mappings, java.util.List excludePatterns)`
    `DefaultUrlMappingsHolder (java.util.List<UrlMapping> mappings, java.util.List excludePatterns, boolean doNotCallInit)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `java.util.Collection<UrlMapping>` | `addMappings(groovy.lang.Closure mappings)`
    `` | `java.util.Set<org.springframework.http.HttpMethod>` | `allowedMethods(java.lang.String uri)`
    `` | `java.util.List` | `getExcludePatterns()`
    `` | `UrlCreator` | `getReverseMapping(java.lang.String controller, java.lang.String action, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String pluginName, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.util.Map params)` @see UrlMappingsHolder#getReverseMapping(String, String, java.util.Map)
    `` | `UrlCreator` | `getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.util.Map params)`
    `` | `UrlCreator` | `getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)`
    `` | `UrlMapping[]` | `getUrlMappings()`
    `` | `void` | `initialize()`
    `` | `protected UrlMapping` | `lookupMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)` Performs a match uses reverse mappings to looks up a mapping from the controller, action and params.
    `` | `UrlMappingInfo` | `match(java.lang.String uri)` @see grails.web.mapping.UrlMappingsHolder#match(String)
    `` | `UrlMappingInfo[]` | `matchAll(java.lang.String uri)`
    `` | `UrlMappingInfo[]` | `matchAll(java.lang.String uri, java.lang.String httpMethod)`
    `` | `UrlMappingInfo[]` | `matchAll(java.lang.String uri, java.lang.String httpMethod, java.lang.String version)`
    `` | `UrlMappingInfo[]` | `matchAll(java.lang.String uri, org.springframework.http.HttpMethod httpMethod)`
    `` | `UrlMappingInfo[]` | `matchAll(java.lang.String uri, org.springframework.http.HttpMethod httpMethod, java.lang.String version)`
    `` | `UrlMappingInfo` | `matchStatusCode(int responseCode)`
    `` | `UrlMappingInfo` | `matchStatusCode(int responseCode, java.lang.Throwable e)`
    `` | `void` | `setMaxWeightedCacheCapacity(int maxWeightedCacheCapacity)`
    `` | `void` | `setUrlCreatorMaxWeightedCacheCapacity(int urlCreatorMaxWeightedCacheCapacity)`
    `` | `java.lang.String` | `toString()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### public static final UrlMappingInfo[] EMPTY_RESULTS

  - ### Constructor Detail

    - #### public DefaultUrlMappingsHolder(java.util.List<UrlMapping> mappings)

    - #### public DefaultUrlMappingsHolder(java.util.List<UrlMapping> mappings, java.util.List excludePatterns)

    - #### public DefaultUrlMappingsHolder(java.util.List<UrlMapping> mappings, java.util.List excludePatterns, boolean doNotCallInit)

  - ### Method Detail

    - #### @java.lang.Override public java.util.Collection<UrlMapping> addMappings(groovy.lang.Closure mappings)

    - #### @java.lang.Override public java.util.Set<org.springframework.http.HttpMethod> allowedMethods(java.lang.String uri)

    - #### public java.util.List getExcludePatterns()

    - #### public UrlCreator getReverseMapping(java.lang.String controller, java.lang.String action, java.util.Map params)

    - #### @java.lang.Override public UrlCreator getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String pluginName, java.util.Map params)

    - #### @java.lang.Override public UrlCreator getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.util.Map params)

    - #### @java.lang.Override public UrlCreator getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)

    - #### public UrlCreator getReverseMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.util.Map params)

      See Also:
        UrlMappingsHolder#getReverseMapping(String, String, java.util.Map)

    - #### public UrlCreator getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.util.Map params)

    - #### @java.lang.Override public UrlCreator getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.util.Map params)

    - #### @java.lang.Override public UrlCreator getReverseMappingNoDefault(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)

    - #### public UrlMapping[] getUrlMappings()

    - #### public void initialize()

    - #### @java.lang.SuppressWarnings("unchecked") protected UrlMapping lookupMapping(java.lang.String controller, java.lang.String action, java.lang.String namespace, java.lang.String pluginName, java.lang.String httpMethod, java.lang.String version, java.util.Map params)

      Performs a match uses reverse mappings to looks up a mapping from the controller, action and params. This is refactored to use a list of mappings identified by only controller and action and then matches the mapping to select the mapping that best matches the params (most possible matches).

      Parameters:
        `controller` - The controller name
        `action` - The action name
        `httpMethod` - The HTTP method
        version
        `params` - The params
      Returns:
        A UrlMapping instance or null

    - #### public UrlMappingInfo match(java.lang.String uri)

      See Also:
        UrlMappingsHolder.match

    - #### public UrlMappingInfo[] matchAll(java.lang.String uri)

    - #### public UrlMappingInfo[] matchAll(java.lang.String uri, java.lang.String httpMethod)

    - #### public UrlMappingInfo[] matchAll(java.lang.String uri, java.lang.String httpMethod, java.lang.String version)

    - #### @java.lang.Override public UrlMappingInfo[] matchAll(java.lang.String uri, org.springframework.http.HttpMethod httpMethod)

    - #### @java.lang.Override public UrlMappingInfo[] matchAll(java.lang.String uri, org.springframework.http.HttpMethod httpMethod, java.lang.String version)

    - #### public UrlMappingInfo matchStatusCode(int responseCode)

    - #### public UrlMappingInfo matchStatusCode(int responseCode, java.lang.Throwable e)

    - #### public void setMaxWeightedCacheCapacity(int maxWeightedCacheCapacity)

    - #### public void setUrlCreatorMaxWeightedCacheCapacity(int urlCreatorMaxWeightedCacheCapacity)

    - #### @java.lang.Override public java.lang.String toString()